<template>
  <el-menu class="navbar" mode="horizontal">
    <el-dialog
      :close-on-click-modal="false"
      title="Cambiar Password"
      :visible.sync="showUpdatePassword"
      width="30%">
      <el-form ref="newPasswordForm" :rules="rules" :model="updatePassword" >
        <el-form-item label="Nuevo Password" prop="newPassword" :required="true">
          <el-input type="password" v-model="updatePassword.newPassword" prefix-icon="key">
            <font-awesome-icon icon="key" slot="prefix" />
          </el-input>
        </el-form-item>
        <el-form-item label="Confirmación Password" prop="confirmPassword" :required="true">
          <el-input type="password" v-model="updatePassword.confirmPassword">
            <font-awesome-icon icon="key" slot="prefix" />
          </el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="showUpdatePassword = false">Cancelar</el-button>
        <el-button type="primary" @click="submitNewPassword">Cambiar</el-button>
      </span>
    </el-dialog>
    <hamburger class="hamburger-container" :toggleClick="toggleSideBar" :isActive="sidebar.opened"></hamburger>
    <breadcrumb></breadcrumb>
    <el-dropdown class="avatar-container" trigger="click">
      <el-button size="small" type="text">
        <img height="30" :src="user.avatar" />
        {{ user.email }}
        <i class="el-icon-arrow-down el-icon--right"></i>
      </el-button>

      <el-dropdown-menu class="user-dropdown" slot="dropdown">.
        <el-dropdown-item divide>
          <span @click="showUpdatePassword = true" style="display:block;">Cambiar Password</span>
        </el-dropdown-item>
        <el-dropdown-item divided>
          <span @click="logout" style="display:block;">Cerrar Sesión</span>
        </el-dropdown-item>
      </el-dropdown-menu>
    </el-dropdown>
  </el-menu>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/feathers'
  import Breadcrumb from '@/components/Breadcrumb'
  import Hamburger from '@/components/Hamburger'
  import app from '@/feathers'
  import auth from '@/services/auth'

  export default {
    components: {
      Breadcrumb,
      Hamburger
    },
    created() {
      this.user = auth.getUser()
      this.api = api
      this.auth = auth
    },
    data() {
      const matchPassword = (rule, value, callback) => {
        if (value !== this.updatePassword.newPassword) {
          callback(new Error('Las contraseñas no coinciden'))
        } else {
          callback()
        }
      }

      return {
        user: {},
        showUpdatePassword: false,
        updatePassword: {
          newPassword: '',
          confirmPassword: ''
        },
        rules: {
          newPassword: [
            { required: true, message: 'Ingrese un nuevo password para continuar', trigger: 'blur' },
            { min: 5, max: 20, message: 'El password debe contener mas de 5 caracteres y menos de 20', trigger: 'blur' }
          ],
          confirmPassword: [
            { required: true, message: 'Ingrese un nuevo password para continuar', trigger: 'blur' },
            { validator: matchPassword, trigger: 'blur' }
          ]
        }
      }
    },
    computed: {
      ...mapGetters([
        'sidebar'
      ])
    },
    methods: {
      submitNewPassword() {
        this.$refs.newPasswordForm
            .validate()
            .catch(
              () => {
                this.$message({
                  type: 'warning',
                  message: 'Falló la validación, por favor verifique los mensajes de error.'
                })
              }
            )
            .then(() => {
              const usersService = api.service('users')
              const user = auth.getUser()
              return usersService.patch(
                user._id, {
                  password: this.updatePassword.newPassword
                })
            })
            .then(() => {
              this.showUpdatePassword = false
              this.updatePassword.newPassword = ''
              this.updatePassword.confirmPassword = ''

              this.$message({
                type: 'success',
                message: 'Password actualizado correctamente'
              })
              // TODO: Ask about how to reset the user with feathers
              location.reload()
            })
            .catch(error => {
              console.log(error)
              this.$message({
                type: 'warning',
                message: 'Hubo un problema al enviar los datos'
              })
            })
      },
      toggleSideBar() {
        this.$store.dispatch('ToggleSideBar')
      },
      logout() {
        this.$emit('logout')
        return app
          .logout()
          .then(() => this.$router.go({name: 'login'}))
      }
    }
  }
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
.navbar {
  height: 50px;
  line-height: 50px;
  border-radius: 0px !important;
  .hamburger-container {
    line-height: 58px;
    height: 50px;
    float: left;
    padding: 0 10px;
  }
  .screenfull {
    position: absolute;
    right: 90px;
    top: 16px;
    color: red;
  }
  .avatar-container {
    height: 50px;
    display: inline-block;
    position: absolute;
    right: 35px;
    .avatar-wrapper {
      cursor: pointer;
      margin-top: 5px;
      position: relative;
      .user-avatar {
        width: 40px;
        height: 40px;
        border-radius: 10px;
      }
      .el-icon-caret-bottom {
        position: absolute;
        right: -20px;
        top: 25px;
        font-size: 12px;
      }
    }
  }
}
</style>
